
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "base.h"
#include "convcar.h"
#include "distribDistans.h"
#include "distribsDistansLet.h"

typedef struct tedistds1Let {
  char *let;
  tdistds distds;
  } * tdistds1Let;

/*

void destruyeDistsdsLet (tdistsdsLet distsdsLet);

*/

void creaDistsdsLet (tdistsdsLet *ndistsdsLet)
{
  *ndistsdsLet = listaNueva ();
}

void creaDistds1Let (tdistds1Let *ndistds1Let, char *let)
{
  tdistds1Let distds1Let;
  distds1Let = (tdistds1Let) malloc (sizeof(struct tedistds1Let));
  distds1Let->let = strdup (let);
  creaDistds ( &(distds1Let->distds) );
  *ndistds1Let = distds1Let;
}

void destruyeDistds1Let (tdistds1Let distds1Let)
{
  free (distds1Let->let);
  destruyeDistds (distds1Let->distds);
  free (distds1Let);
}

Boolean localizaDistds1Let (tdistds *distds, tdistsdsLet distsdsLet, char *ch)
{
  Boolean encontrado;
  tnodol nodol;
  encontrado = FALSE;
  *distds = 0L;
  if (distsdsLet->primero != 0L)
    for (nodol = distsdsLet->primero; nodol != 0L;nodol = nodol->siguiente) {
      tdistds1Let distds1Let;
      distds1Let = (tdistds1Let) (nodol->aitem);
      if (strcmp(distds1Let->let, ch) == 0){
        *distds = distds1Let->distds;
        encontrado = TRUE;
        break;
        }
      }
  return encontrado;
}

void ponDiEnDistsdsLet (tdistsdsLet distsdsLet, char *ch, int di)
{
  tdistds1Let distds1Let;
  tdistds distds;
  if ( ! localizaDistds1Let(&distds, distsdsLet, ch) ){
    creaDistds1Let (&distds1Let, ch);
    aniadeafinlista (distsdsLet, distds1Let);
    distds = distds1Let->distds;
    }
  ponDiEnDistds (distds, di);
}

void ndisEnDistsdsLet (int *ndis, tdistsdsLet distsdsLet, char *ch)
{
  tdistds distds;
  if ( ! localizaDistds1Let(&distds, distsdsLet, ch) ){
    *ndis = 0;
    }
  else
    ndisEnDistds (ndis, distds);
}

void posicionEnDistsdsLet (int *pos, int *ndis, int *moda, tdistsdsLet distsdsLet, char *ch, int di)
{
  tdistds distds;
  if ( ! localizaDistds1Let(&distds, distsdsLet, ch) ){
    *pos = 0;
    *ndis = 0;
    *moda = 0;
    }
  else
    posicionEnDistds (pos, ndis, moda, distds, di);
}

void escribeDistds1Let (tpgen item)
{
  tdistds1Let distds1Let;
  distds1Let = (tdistds1Let)item ;
  printf ("%s ", distds1Let->let);
  escribeDistds ( distds1Let->distds );
}

void escribe1Let (tpgen item)
{
  tdistds1Let distds1Let;
  char carsus[1024];
  distds1Let = (tdistds1Let)item ;
  ssalidaDeUtf (carsus, distds1Let->let);
  printf ("%s", carsus);
}

void escribeDistsdsLet (tdistsdsLet distsdsLet)
{
  recorreListaAplicando (distsdsLet, escribeDistds1Let);
  printf ("\n");
}

void escribeDLet (tdistsdsLet distsdsLet)
{
  recorreListaAplicando (distsdsLet, escribe1Let);
  printf ("\n");
}
