
// dom mar  5 16:54:55 CET 2017
// version anterior en  arm7
/// dom jun 14 12:25:08 CEST 2015
/// version anterior en  arm6

#include <libintl.h>
#include <locale.h>
#define _(mens) gettext(mens)
#define N_(mens) (mens)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "aplica.h"
#include "base.h"
#include "config.h"
#include "estad.h"
#include "glifos.h"
#include "grises.h"
#include "histos.h"
#include "histosx.h"
#include "inclina.h"
#include "imag.h"
#include "imagx.h"
#include "lectura.h"
#include "lista.h"
#include "line.h"
#include "lvent.h"
#include "opcns.h"
#include "reconoce.h"
#include "segmenta.h"
#include "segmenta3.h"
#include "tarea.h"

// comienzo_local

// static char * nombreTipoDocumento[] = {
//   "tdocumNoclasif", "tdocumColumna", "tdocumTabloide",
//   "#"
// };

tglifo glifoHoja0 ;       // para depurar
int gln1 = 0;             // para depurar

void tipoDocumento (ttdocum *tdocum, tvent vent)
{
  prepara0 (vent);
    *tdocum = tdocumNoclasif;
//    *tdocum = tdocumTabloide;
}

// --------------- segmenta ...  ---------------

void segmentaPsjsRayaN (tvent vent, lista lineas)
{
  int localt = 0;
  tnodol nodol;
  // int inclabs;
  tline linea;
  tvent ventanaLimpia;
  int tam, incl = 0;  // ??
  int yant = 0;
  int inod, nnod;
  tglifo glifoVent;
  tglifo glifovlim;
  glifoVent = GLIfoDeVen(vent);
  glifoVent->relpartes = sepHorRayaNeg;
  nnod = longLista (lineas);
          if (localt) imprimeRayasCab (lineas, "rayas horizontales");
  //       n lineas -> n+1 piezas
  nodol = lineas->primero;
  for (inod = 0; inod <= nnod ; inod ++){
              if (localt) printf ("anyadir ventana y glifo de raya horiz.a\n");
    if (inod != nnod) {
      linea = (tline) nodol->aitem;
      tam = linea->v0 - yant - 1;
      }
    else
      tam = (vent->ty - 1) - yant - 1;
    // inclabs = linea->incl*vent->ty/256/256;
    if (tam > 40) 
      ventanaEnVentanaLargHor (&ventanaLimpia, vent, yant, tam);
    if (tam > 40) {
      ponerConvenVentana (ventanaLimpia, vent->conv);
      ventanaLimpia->incl = 0 ;                    // ??
      // printf ("inclinacion: %5d\n", incl);
      //  presentaVentana (&nh, vcaracterLimpia, "sal36e.pgm", 1); para (); exit (0);
      ventanaLimpia->incl = incl ;
      anyadeVentana (vent->lvint, ventanaLimpia);
      // describeVentanas (vent, 0);   // en glifos
      glifovlim = glifoCompPaginaNuevo ();
      casaGlifoVent (glifovlim, ventanaLimpia);
      adoptaGlifo (glifoVent, glifovlim);
      }
    if (inod != nnod) {
      yant = linea->v1 + 1 ; 
      nodol = nodol->siguiente;
      }
  }
}

void segmentaColsRayaN (tvent vent, lista lineas)
{
  int localt = 0;
  tnodol nodol;
  int xant;
  int inclabs;
  tline linea;
  tvent ventanaLimpia;
  int tam, incl = 0;;
  int ultimo = 0;
  tglifo glifoVent;
  tglifo glifovlim;
  glifoVent = GLIfoDeVen(vent);
  glifoVent->relpartes = sepVerRayaNeg;
          if (localt) imprimeRayasCab (lineas, "rayas verticales");
  xant = 0;
  // printf ("vent->tx: %4d longLista(lineas) %3d\n", vent->tx, longLista(lineas));
  for (nodol = lineas->primero; ! ultimo ;) {
    // ventanaEnVentanaLargVer (&vcaracter, vent,
    //                          max (0, corte->u0 + dxinc),
    //                          tamanyoSegm (corte) + txinc);
    // ventanaLimpDeVentanaIncl (&vcaracterLimpia, vcaracter, fondo);
    if (nodol != (tnodol)0L) {
      linea = (tline) nodol->aitem;
      inclabs = linea->incl*vent->ty/256/256;
      tam = linea->v0 - xant - 1;
      if (tam > 90) {
        // ventanaEnVentanaLargVer (&ventanaLimpia, vent, xant, tam);
        ventanaEnVentanaLargVerInclLimpConMargen0
                              (&ventanaLimpia, vent,
                               xant, tam, inclabs);
        }
      xant = linea->v1 + 1 ;
      }
    else {                                   // nodol == (tnodo)0L
      tam = (vent->tx - 1) - xant - 1;
      if (tam > 90)
        // ventanaEnVentanaLargVer (&ventanaLimpia, vent, xant, tam);
        ventanaEnVentanaLargVerInclLimpConMargen0
                              (&ventanaLimpia, vent,
                               xant, tam, inclabs);
      // xant = vent->tx + 1;
      ultimo = 1;
      }
    if (tam > 90) {
      ponerConvenVentana (ventanaLimpia, vent->conv);
      ventanaLimpia->incl = 0 ;                    // ??
      // printf ("inclinacion: %5d\n", incl);
      //  presentaVentana (&nh, vcaracterLimpia, "sal36e.pgm", 1); para (); exit (0);
      ventanaLimpia->incl = incl ;
      anyadeVentana (vent->lvint, ventanaLimpia);
      // describeVentanas (vent, 0);
      glifovlim = glifoCompPaginaNuevo ();
      casaGlifoVent (glifovlim, ventanaLimpia);
      adoptaGlifo (glifoVent, glifovlim);
      } 
    if (nodol != (tnodol)0L)
      nodol = nodol->siguiente;
    }
}

void segmentaPsjsRayaB (tvent vent)
{
  // int localt = 0;
  tglifo glifoVent;
  tglifo glifovlim;
  lista lis_ven;
  tnodol nodol;
  glifoVent = GLIfoDeVen(vent);
  glifoVent->relpartes = sepHorRayaBln;
  lis_ven = vent->lvint;
  tvent vent_paisj;
  for (nodol=lis_ven->primero; nodol != (tnodol)0L; nodol = nodol->siguiente) {
    vent_paisj = nodol->aitem;
    glifovlim = glifoCompPaginaNuevo ();
    adoptaGlifo (glifoVent, glifovlim);
    casaGlifoVent (glifovlim, vent_paisj);
    }
}

void segmentaColsRayaB (tvent vent)
{
  // int localt = 0;
  tglifo glifoVent;
  tglifo glifovlim;
  lista lis_ven;
  tnodol nodol;
  glifoVent = GLIfoDeVen(vent);
  glifoVent->relpartes = sepVerRayaBln;    // unica dif. con Psj
  lis_ven = vent->lvint;                   // nombre dif. (trivial)
  tvent vent_col;
  for (nodol=lis_ven->primero; nodol != (tnodol)0L; nodol = nodol->siguiente) {
    vent_col = nodol->aitem;
    glifovlim = glifoCompPaginaNuevo ();
    adoptaGlifo (glifoVent, glifovlim);
    casaGlifoVent (glifovlim, vent_col);
    }
}

int niv_seg = 0;

void segmentaTabloide (tvent vent);

void resegmentaTabloide (tvent vent)
{
  int localt = 0;
  lista ventanas;
  tnodol nodol;
  tvent v;  // , vx, vsub;
          if (localt) printf ("%*sentra en resegmentaTabloide\n", 2*niv_seg, "");
  niv_seg ++;
  ventanas = vent->lvint;
  for (nodol=ventanas->primero; nodol != 0L; nodol=nodol->siguiente) {
    v = (tvent) (nodol->aitem);
    segmentaTabloide (v);
                        /* v->lvint = vx->lvint;       // y Faltan los enlaces hijas -> madre */
    }
  niv_seg --;
          if (localt) printf ("%*ssale de resegmentaTabloide\n", 2*niv_seg, "");
}

Boolean segmenta_tbl_ng_horz (tvent vent, lista lineasHagr)
{
  int localt = 0;
  lista lineasLarHagr;
  lista lineasLargasOv, lineasLargasOvCrec ;
  tvent *nventcuer;     // temporal
                   if (localt==2) printf ("=============nh0 %3d\n", longLista(lineasHagr));
  if (longLista(lineasHagr) != 0) {
     nlineasMasLargas (&lineasLarHagr, lineasHagr, 6);
     eliminaLineasMenores (lineasLarHagr, (vent->tx * 7)/10 );
                   if (localt==2) printf ("=============nh1 %3d\n", longLista(lineasLarHagr));
    if ((longLista(lineasHagr) != 0) && (longLista(lineasLarHagr) > 0)) {
                     if (localt) printf ("%*ssegm_n_h %3d\n",
                                         2*niv_seg, "", longLista(lineasLarHagr));
       ordenaPor_vx (&lineasLargasOv, lineasLarHagr);
       lineasLargasOvCrec = copiaListaReves (lineasLargasOv);
               if (localt) printf ("%*sa segmentaPsjsRayaN %4d\n",
                                    2*niv_seg, "", longLista(lineasLarHagr));
       segmentaPsjsRayaN (vent, lineasLargasOvCrec);    // N0
                          // describeVentanas (vent, 1); printf ("\n");
       resegmentaTabloide (vent);
                          // describeVentanas (vent, 2);
       *nventcuer = vent;
       return TRUE;
       }
     }
  return FALSE;
}

Boolean segmenta_tbl_ng_vert (tvent vent, lista lineasVagr)
{
  int localt = 0;
  lista lineasLarVagr ;
  lista lineasLargasOv, lineasLargasOvCrec ;
  // tvent *nventcuer;     // temporal
                   if (localt) printf ("=============nv0 %3d\n", longLista(lineasVagr));
  if (longLista(lineasVagr) != 0) {
     nlineasMasLargas (&lineasLarVagr, lineasVagr, 6);
     eliminaLineasMenores (lineasLarVagr, (vent->ty * 7)/10 );
                   if (localt) printf ("=============nv1 %3d\n", longLista(lineasLarVagr));
    if (longLista(lineasLarVagr) > 0) {
       ordenaPor_vx (&lineasLargasOv, lineasLarVagr);
       lineasLargasOvCrec = copiaListaReves (lineasLargasOv);
               if (localt) printf ("%*sa segmentaColsRayaN %4d\n",
                                    2*niv_seg, "", longLista(lineasLarVagr));
       segmentaColsRayaN (vent, lineasLargasOvCrec);
                          // describeVentanas (vent, 1); printf ("\n");
       resegmentaTabloide (vent);
                          // describeVentanas (vent, 2);
       // *nventcuer = vent; // temporal ?
       return TRUE;
       }
     }
  return FALSE;
}

// AQUI_Y_ AHORA
// escribe caracteristicas vent y vent->lvint
void origenesParceladoVent (tvent vent)
{
  int localt = 0;
  tdcaracHistoGr carHgri;
  tnodol nodol;
  tvent venti;
          if (localt) printf ("vnid: %4d de ..: %4d",
                               vent->nid,
                               vent->imaBase->venOrig->venBase->nid);
          if (localt) if (vent->imaBase->venOrig->venBase->nid > 4){
                        printf (" de ..: %4d",
              vent->imaBase->venOrig->venBase->imaBase->venOrig->venBase->nid);
              printf (" tx: %4d ty:%4d\n", vent->tx, vent->ty);
              escribeCaracHistoGr (carhisgrDeVentanaCalculado (vent));
              printf ("\n");
              }
  for (nodol=vent->lvint->primero; nodol != (tnodol)0L; nodol = nodol->siguiente) {
    venti = (tvent) (nodol->aitem);
            if (localt) printf (" tx: %4d ty:%4d\n", venti->tx, venti->ty);
    carHgri = carhisgrDeVentanaCalculado (venti);
    if (carHgri->desvN < 0) {
      eliminaNdelista (vent->lvint, nodol);
              if (localt) printf ("eliminado nodo de parcela corte blanco vertical 1\n");
      }
    else {
              if (localt) escribeCaracHistoGr (carHgri);
      }
            if (localt) printf ("\n");
    }
          if (localt) printf ("\n");
}

Boolean segmenta_tbl_bl_vert (tvent vent, lista lineasVblanLAgr)
{
  int localt = 0;
  int incly_64k;
  int hisV[MAXPIXH];
  int hisVpr[MAXPIXH];
  int ncols;
  if (vent->tx < 800)
    return FALSE ;
  prepara0 (vent);
  incly_64k = calculaInclinacionV (vent);
  histoVerInclLinb (hisV, vent, incly_64k, 10);
  aplicaV (hisV, hisVpr, vent->tx, 8, prom);
  segmentaCols (vent, hisVpr, incly_64k);    // vistos en horizontal
          if (localt) { tvent vent2;
                        vent2 = seleccionaSubventana (vent, "car");
                        presentaVentanayEspera (vent2, "sal36x1.pgm", 1); }
  ncols = longLista (vent->lvint);
          if (localt) printf ("en segmenta_tbl_bl_vert, ncols: %2d\n", ncols);
  if (ncols > 1)
          if (1 || localt) origenesParceladoVent (vent);
  if (ncols > 1) {
    segmentaColsRayaB (vent);
    resegmentaTabloide (vent);
    }
  return ncols > 1;
}

Boolean segmenta_tbl_bl_horz (tvent vent, lista lineasHagr) 
{
  int localt = 0;
  int incl_64k;
  int hisH[MAXPIXV];
  int hisHpr[MAXPIXV];
  int npsjs;
  prepara0 (vent);  // quiza no haga falta, hecho antes
  incl_64k = calculaInclinacionH (vent);
  histoHorInclLinb (hisH, vent, incl_64k, 10);
  aplicaV (hisH, hisHpr, vent->ty, 8, prom);
  segmentaPsjs (vent, hisHpr, incl_64k);    // vistos en vertical
                    //  if (vent->nid == 65) presentaVentanayPara (vent, "sal36x3.pgm", 1);
          if (localt) { tvent vent2;
                        vent2 = seleccionaSubventana (vent, "car");
                        presentaVentanayEspera (vent2, "sal36x2.pgm", 1); }
  npsjs = longLista (vent->lvint);
          if (localt) printf ("en segmenta_tbl_bl_horz, npsjs: %2d\n", npsjs);
  if (npsjs > 1)
          if (1 || localt) origenesParceladoVent (vent);
  if (npsjs > 1) {
    segmentaPsjsRayaB (vent);
    resegmentaTabloide (vent);
    }
  return npsjs > 1;
}

// --------------- segmenta ---------------

void segmentaTabloide (tvent vent)
{
  int localt = 0;
  lista lineasHagr;
  lista lineasVagr;
  lista lineasVblanLAgr;
  lista lineasHblanAgr;
  // tvent vent_si;
  int incly_64k;  // , incl_64k;
          if (localt) printf ("%*sentra en segmentaTabloide %4d %4d %4d %4d\n", 2*niv_seg, "",
                               vent->dx, vent->tx, vent->dy, vent->ty);
  niv_seg ++;
  prepara0 (vent);
          if (localt==3) { if (gln1 <= 50) {
                            presentaVentanayEspera (vent, "tmpi/sal_tr_nn", 1);
                            presentaHistogramaGrisesyEspera (vent, "tmpi/sal_hg");
                            }
                          gln1 ++;
                          }
  incly_64k = calculaInclinacionV (vent);
  // incl_64k  = calculaInclinacionH (vent);
          if (localt == 2) {printf ("=-\n"); describeVentanas (vent, 2); printf ("=-\n");}
  // sigueyAgrupaRayasHor (&lineasHagr, vent);
  // sigueyAgrupaRayasVer (&lineasVagr, vent);
//
  sigueyAgrupaRayasHor (&lineasHagr, vent);
  sigueyAgrupaRayasVer (&lineasVagr, vent);
  sigueyAgrupaRayasVerBlanIncl (&lineasVblanLAgr, vent, (vent->ty * 31)/ 32, incly_64k);
  sigueyAgrupaRayasHorBlan (&lineasHblanAgr, vent, (vent->tx * 31)/ 32);
//
          if (localt==2) if (gln1 <= 0) {
                           imprimeRayasCab (lineasVagr, "rayas n. verticales");
                           imprimeRayasCab (lineasHagr, "rayas n. horizontales");
                           // exit (1);
                           }
//
  if      ( segmenta_tbl_ng_horz (vent, lineasHagr)) {}
  else if ( segmenta_tbl_ng_vert (vent, lineasVagr)) {}
  else if ( segmenta_tbl_bl_vert (vent, lineasVblanLAgr)) {}
  else if ( segmenta_tbl_bl_horz (vent, lineasHblanAgr)) {}
  else
  niv_seg --;
          if (localt) printf ("%*ssale de segmentaTabloide\n", 2*niv_seg, "");
}

// --------------- xxxxx ---------------

lista localiza_imagenes (tvent vent)
{
  int localt = 0;
  // int incly_64k;
  lista gruposLin;
  lista lineasHagr;
  lista lineasVagr;
  lista lineasLarHagr;
  lista lineasLarVagr;
  lista g_lh, g_lv;
  tnodol nodol;
  int x_e, x_o, y_n, y_s;
  int xm_e, xm_o, ym_n, ym_s;     // ... con margen
  tline ln_e, ln_o, ln_n, ln_s;
  tvent venti;
  lista lventi;
  prepara0 (vent);
  // incly_64k = calculaInclinacionV (vent);
  sigueyAgrupaRayasHor (&lineasHagr, vent);
  sigueyAgrupaRayasVer (&lineasVagr, vent);
            if (localt) imprimeRayasCab (lineasHagr, "en grupo lineas h, lineasHagr");
  //
  nlineasMasLargas (&lineasLarHagr, lineasHagr, 30);
  nlineasMasLargas (&lineasLarVagr, lineasVagr, 30);
  agrupaLineasQueSeCortan (&gruposLin, lineasLarHagr, lineasLarVagr);
  // eliminaDeListaSiFuncEResul (gruposLin, (tpgen) 3, longListaMenorQue, TRUE);
          if (localt) imprimeGruposRayasCab (gruposLin, "grupo lineas se cortan");
  lventi = listaNueva ();
  for (nodol=gruposLin->primero; nodol != (tnodol)0L; nodol = nodol->siguiente) {
    g_lh = lineasdeOrientacion (nodol->aitem, 'h');
    g_lv = lineasdeOrientacion (nodol->aitem, 'v');
    if ((longLista(g_lh) > 0) && (longLista(g_lv) > 0)) {
              if (localt) imprimeRayasCab (g_lh, "en grupo lineas h, g_lh");
              if (localt) imprimeRayasCab (g_lv, "en grupo lineas v, g_lv");
      ln_n = (tline) ( minimIEnlista (g_lh, v0_de_linea)->aitem ) ;
      ln_s = (tline) ( maximIEnlista (g_lh, v1_de_linea)->aitem ) ;
      ln_o = (tline) ( minimIEnlista (g_lv, v0_de_linea)->aitem ) ;
      ln_e = (tline) ( maximIEnlista (g_lv, v1_de_linea)->aitem ) ;
      //
      y_n = ln_n->v0 ;        y_s = ln_s->v1 ;
      x_o = ln_o->v0 ;        x_e = ln_e->v1 ;
      ym_n = max (y_n - 6, 0);   ym_s = min (y_s + 6, vent->ty -1);
      xm_o = max (x_o - 6, 0);   xm_e = min (x_e + 6, vent->tx -1);
      ventanaEnVentana (&venti, vent, xm_o, ym_n, xm_e-xm_o+1, ym_s-ym_n+1);
            if (localt) { printf ("\n y_n: %4d y_s: %4d x_o: %4d x_e: %4d\n\n",
                                      y_n,     y_s,     x_o,     x_e);
                          presentaVentanayEspera (venti, "tmpi/sal_tr_im", 1);
                        }
      aniadeafinlista (lventi, venti);
      }
    }
  return lventi;
}

void elimina_imagenes (tvent *vent_si, tvent vent, lista lventi)
{
  int localt = 0;
  tdcaracHistoGr carHisGr;
  timagf nimag;
  tvent nvent;
  tnodol nodol;
  tvent vi;
  carHisGr = carhisgrDeVentana (vent);
  copiaImagenDeVentana (&nimag, vent);
  nvent = nimag->ven0;
  for (nodol=lventi->primero; nodol != (tnodol)0L; nodol = nodol->siguiente) {
            if (localt) printf ("borrar imagen en lista\n");
    vi = (tvent) nodol->aitem;
    rectanguloGrisEnVentana (nvent, vi->dx, vi->dy, vi->tx, vi->ty,
                             ((carHisGr->xblanco * 18) + 255 * 2)/20 );
             //                carHisGr->xnegro);
    }
  *vent_si = nvent;
}

void separa_imagenes (tvent *vent_si, tvent vent)
{
  int localt = 0;
  lista lventi;
  tvent nvent;
  lventi = localiza_imagenes (vent);
  elimina_imagenes (&nvent, vent, lventi);
          if (localt) presentaVentanayEspera (nvent, "tmpi/sal_tr_im", 1);
  *vent_si = nvent ;
          if (localt == 3) exit (1);
}

// --------------- segmenta tabloide ---------------

int nven = 0; 

// --------------- lee ---------------

void leeHoja0 (tvent vent, int *n)
{
  int localt = 0;
  tnodol nodol;
  lista lvent;
  char nmf [128];
  tglifo nglifoH;
  lvent = vent->lvint;
  if (longLista(lvent) != 0)
    for (nodol = lvent->primero; nodol != (tnodol)0L; nodol = nodol->siguiente) {
      leeHoja0 ((tvent)(nodol->aitem), n);
      }
  else {
    sprintf (nmf, "salparce_%c.pgm", 'a' + nven++);
    // escribeVentana (vent, nmf);
    // leedeColumnas (&nglifoH, vent, &n);
    segmReconoceRepasayEscribeColumnaP (&nglifoH, vent, n);
            if (localt) printf ("ventana %s\n", nmf);
    }
}

void leeHoja (tglifo glifoHoja)
{
  int localt = 0;
  int n = 0;
  leeHoja0 (glifoHoja->venDeGlifo, &n);
          if (localt) printf ("fin en leeHoja\n");
}

void segmentayLeeTabloide (tglifo *nglifoH, tvent vent, int *n)
{
  int localt = 0;
  tglifo glifoHoja;
  tvent vent_si;
  glifoHoja = glifoCompPaginaNuevo ();
  glifoHoja0 = glifoHoja;
  separa_imagenes (&vent_si, vent);
  casaGlifoVent (glifoHoja, vent_si);
 // 
  pon_margen_dy_reconoceCar (7);
  segmentaTabloide (vent_si);
          if (localt == 2) {
            int nivs=0;
            // printf ("describeGlifo (glifoHoja, %d);\n", nivs);
            // describeGlifo (glifoHoja, nivs);
            // // enmarcaRGlifo (glifoHoja, nivs, nivs);
            // // presentaVentanayEspera (vent, "tmpi/sal_tr_enm", nivs);
            aficheroRGlifo (glifoHoja, nivs, "tmpi/sal_tr_afR");
            // exit (1);
            }
  leeHoja (glifoHoja);
  *nglifoH = glifoHoja;
}

void eliminaBordes (tvent *nventl, tvent vent)
{
  lista lineasVagr ;
  lista lineasHagr ;
  tline lineaOeste;  //   , lineaEste;
  tline lineaNorte;
  int xi, xf, yi, yf;
  xi = 0;
  yi = 0;
  xf = vent->tx - 1;
  yf = vent->ty - 1;
  sigueyAgrupaRayasVer (&lineasVagr, vent);
  // imprimeRayasCab (lineasVagr, "eliminaBordes, rayas n. verticales");  //
  if (! listaVacia (lineasVagr)) {
    lineaOeste = (tline) lineasVagr->primero->aitem ;
    if (((lineaOeste->u1 - lineaOeste->u0)*20 >= (vent->ty - 1)*19) &&  // largo+
        ((lineaOeste->v1 - lineaOeste->v0)    <  (vent->ty    )/12) &&  // ancho-
         (lineaOeste->v0 <= 2)) {
      xi = lineaOeste->v1 + 4 ;
      }
    // lineaEste = (tline) lineasVagr->ultimo->aitem ;
//    if (((lineaEste->u1 - lineaEste->u0)*20 >= (vent->ty - 1)*19) &&
//         (xf - lineaEste->v1 <= 2)) {
//      xf = lineaEste->v0 - 4 ;
//      }
    }
//
  sigueyAgrupaRayasHor (&lineasHagr, vent);
  if (! listaVacia (lineasHagr)) {
    // imprimeRayasCab (lineasHagr, "rayas n. horizontales");
    lineaNorte = (tline) lineasHagr->primero->aitem ;
    if (((lineaNorte->u1 - lineaNorte->u0)*20 >= (vent->tx - 1)*19) &&
         (lineaNorte->v0 <= 2)) {
      yi = lineaNorte->v1 + 4 ;
      }
    }
  // printf ("eliminaBordes: xi:%4d xf:%4d\n", xi, xf);  //
  ventanaEnVentana (nventl, vent, xi, yi, xf-xi+1, yf-yi+1);
}
