
#ifndef _SENIAL_H
#define _SENIAL_H

#include "base.h"

typedef struct tvder{
  int n;
  int deriv;
  int * mins,  * maxs;
  int * minsp, * maxsp ;
  int * prom,  * umbr ;
  } * tvectder ;

typedef struct teparsSenial{
  int anMax;
  int anPromMax;
  int anMin;
  int anPromMin;
  int anProm;
  int nivCh;
  } tparsSenial ;
#endif

tvectder vectderAlloc (int n);

tvectder dervectder (tvectder vectder, int del, int n);

void vectderFree (tvectder vectder);

void paraCortes (tvectder *nvectder, int *his, int tv, tparsSenial parsCorte, char *nomCor);

void presentaHisVectder (int *nnh, int * his, tvectder vectder, char *nfd, char *nfi);

void convolucionPromedio (int ** nvs, int * ve, int tamVec, int anchProm);

void convolucionDifPromedio (int ** nvs, int * ve, int tamVec, int anchProm);

void convolucionDif2Promedio (int ** nvs, int * ve, int tamVec, int anchProm);

