
#include <errno.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

void listaAarray (char *** na, int n, ...)
{
  va_list arg_p;
  char ** a;
  int i;
  a = (char **) malloc ((n+1) * sizeof (char *));
  va_start(arg_p, n);
  for (i=0; i<n; i++)
    a[i] = va_arg(arg_p, char *);
  va_end(arg_p);
  a[n] = (char *) 0L;
  *na = a;
}

void listaAarrayConcopia (char *** na, int n, ...)
{
  va_list arg_p;
  char ** a;
  int i;
  a = (char **) malloc ((n+1) * sizeof (char *));
  va_start(arg_p, n);
  for (i=0; i<n; i++)
    a[i] = strdup(va_arg(arg_p, char *));
  va_end(arg_p);
  a[n] = (char *) 0L;
  *na = a;
}

void condensaArrayAcumInt (int * acon, int * a, int na, int fc)
{
  int i, j, iul, jul;
  iul = na - 1;
  jul = iul / fc;
  for (j=0; j <= jul; j++)
    acon [j] = 0;
  for (i=0; i <= iul; i++)
    acon[i/fc] += a[i];
}

void ordenaVint (int * v, int n)
{
int i, j;
int x;
  if (n > 1) 
    for (i=0; i<(n-1); i++)
      for (j=i+1; j<n; j++)
        if (v[j] < v[i]){
          x     = v [j] ;
          v [j] = v [i] ;
          v [i] = x ;
        }
}

void ordenaVint2 (int * v, int i1, int i2)
{
  ordenaVint (&(v[i1]), i2-i1+1);
}

void syserr(char *msg) /* print system call error message and terminate */
{
	extern int errno;
	fprintf (stderr, "ERROR: %s (%d", msg, errno);
	fprintf(stderr, "; %s)\n", strerror(errno));
	exit (1);
}

void fatal(char *msg) /* print error message and terminate */
{
	fprintf (stderr, "ERROR: %s \n", msg);
	exit (1);
}
