
#include <stdio.h>
#include <stdarg.h>
#include "errors.h"

void escribeComGnuplotSimp (char *nfi, char *nfd, char *cols)
{
  FILE * fd;
  fd = fopen (nfi, "w");
  fprintf(fd, "plot \042%s\042 using %s with lines\n", nfd, cols);
  // fprintf(fd, "pause -1\n");
  fprintf(fd, "pause 5\n");
  fclose(fd);
}

void escribeComGnuplotMult (char *nfi, char *nfd, int n, ...)
{
  va_list arg_p;
  FILE * fd;
  int i;
  char *cols, *etiq;
  fd = fopen (nfi, "w");
  compruebaFd (fd, nfi, "plot.escribeComGnuplotMult");
  fprintf(fd, "plot ");
  va_start(arg_p, n);
  for (i=1; i<=n; i++){
    cols = va_arg(arg_p, char *);
    etiq = va_arg(arg_p, char *);
    if (i>1) fprintf(fd, "     ");
    fprintf(fd, "\042%s\042 using %s title \042%s\042 with lines",
                 nfd, cols, etiq);
    if (i<n) fprintf(fd, ", \\");
    fprintf (fd, "\n");
    }
  va_end(arg_p);
  fprintf(fd, "pause -1\n");
  fclose(fd);
}

void escribeComGnuplotMult2 (char *nfi, char *nfd, int n)
{
  FILE * fd;
  int i;
  fd = fopen (nfi, "w");
  compruebaFd (fd, nfi, "plot.escribeComGnuplotMult2");
  fprintf(fd, "plot ");
  for (i=1; i<=n; i++){
    if (i>1) fprintf(fd, "     ");
    fprintf(fd, "\042%s\042 using 1:%1d title \042%1d\042 with lines",
                 nfd, i+1, i-1);
    if (i<n) fprintf(fd, ", \\");
    fprintf (fd, "\n");
    }
  fprintf(fd, "pause -1\n");
  fclose(fd);
}

