
#include "base.h"
#include "lista.h"

typedef struct tesegm{
  int u0, u1;
  } * tsegm;

int centroSegm (tsegm segm);

void anyadeSegm (lista segmentos, int u0, int u1);

int tamanyoSegm (tsegm segm);

int tamanyoIntersegmSig (tnodol nodol);

void eliminaUltimoSegm (lista segmentos);

void uneasegmentoSiguiente (lista segmentos, tnodol nodoseg);

void imprimeSegmentos (lista segmentos);

void imprimeHuecos (lista segmentos);

void imprimeSegmentosyHuecos (lista segmentos);

void desplazaSegmentos (lista segmentos, int desp);

void segmentosBajoUmbral (lista * nsegm, int *v, int vt, int umbral);

void segmentosSobreoenUmbral (lista * nsegm, int *v, int vt, int umbral);

Boolean enSegmento (tsegm *vsegm, lista segmentos, int u);

void intersecSegmentos2 (lista * ncortes, lista blosr, lista blosi, int alturaLin);
 
lista eliminaHuecosMenores (lista lsegms, int umbr);

lista reuneSegmentosMenores (lista lsegms, int umbr);  // con anterior si es posible

lista unionNnSegmentos (lista lsegms1, lista lsegms2);

lista interseccionNnSegmentos (lista lsegms1, lista lsegms2);

void huecosUnionSegmentos (lista * ncortes, lista blosr, lista blosi, int alturaLin);

void huecosInterseccionSegmentos (lista * ncortes, lista blosr, lista blosi, int alturaLin);

